/* LIST.H ************************************************************** 
** ALang Execution/Mutation Engine: Version 0.61
** Part of Project von Neumann
** Copyright Dr I G Badcoe (I.Badcoe"bristol.ac.uk),
**           Toby Dickenson (htrd@tcp.co.uk) and
**           the Directors of Project von Neumann.
**
** License is granted for the use of this software only as part of
** Project von Neumann.
*/

#ifndef _LIST_H_
#define _LIST_H_

#include "platform.h"
#include "cnstants.h"
#include "preamble.h"

/*
** AL_ListHead and AL_ListEntry make the lists for use by ALang.
*/

struct AL_ListHead {
  int nentries;
  struct AL_ListEntry *first;
  union {
    struct AL_ListEntry *last;
    struct AL_ListHead *next_free;
  } detail;
};

struct AL_ListEntry {
  struct AL_ListEntry *next;
  EINT32 value;
};

void append_list(struct AL_ListHead * to, struct AL_ListHead * from);
void append_entry(struct AL_ListHead * to, struct AL_ListEntry * from);

struct AL_ListEntry *pop_entry(struct AL_ListHead * from);
void push_entry(struct AL_ListHead * to, struct AL_ListEntry * who);

#endif /* _LIST_H_ */
