/* LIST_N.C ************************************************************** 
** ALang Execution/Mutation Engine: Version 0.61
** Part of Project von Neumann
** Copyright Dr I G Badcoe (I.Badcoe"bristol.ac.uk),
**           Toby Dickenson (htrd@tcp.co.uk) and
**           the Directors of Project von Neumann.
**
** License is granted for the use of this software only as part of
** Project von Neumann.
*/

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "attrib.h"
#include "stack.h"
#include "list.h"
#include "exec.h"
#include "nodetype.h"
#include "tab.h"
#include "memory.h"
#include "macros.h"

#include "list.h"

/******************************* SER *******************************
** generate a list of ints ranging from its first value to its second
*/

void SER_exe() {
  int i;
  struct AL_ListEntry *temp;

  if (STATUS < 2) {
    ENTER_NODE(CHILD(THISNODE, STATUS++));
    return;
  }

  append_list(&FreeEntries, CURRENT_LIST);
  for(i = IARG(0); i <= IARG(1); i++) {
    temp = get_entry();
    temp->value = i;
    append_entry(CURRENT_LIST, temp);
  }

  PRETVAL = CURRENT_LIST;
  EXIT_NODE();
}

void SER_res(AL_Attrib ret_type,
            struct AL_Node * where,
            int i,
            AL_Attrib buffer) {
  if (!ACCEPTS_ATTR(ret_type[0], LIST_ATTR | VAL_ATTR | RET_ATTR)) {
    buffer[0] = ERROR_ATTR;
    return;
  }
  if (i < 2) {
    buffer[0] = INT_ATTR | SING_ATTR | VAL_ATTR | RET_ATTR |
                DEL_ATTR | INS_ATTR;
  } else {
    buffer[0] = ERROR_ATTR;
  }
}

void SER_attr(struct AL_Node * where, AL_Attrib buffer) {
  DECL_ATTRIB(temp);
  buffer[0] = INT_ATTR | SING_ATTR | VAL_ATTR | RET_ATTR;
  ATTR(CHILD(where, 0), temp);
  MIX_FLAGS(buffer, temp);
  ATTR(CHILD(where, 1), temp);
  MIX_FLAGS(buffer, temp);
}

/******************************* SER *******************************
** generate an empty list, holding either:
**	(a) no ints, or, 
**	(b) no objs
**		as approppriate (:-)
*/

void EMPTY_exe() {
  append_list(&FreeEntries, CURRENT_LIST);

  PRETVAL = CURRENT_LIST;
  EXIT_NODE();
}

void EMPTY_attr(struct AL_Node * where, AL_Attrib buffer) {
  buffer[0] = SING_ATTR | VAL_ATTR | RET_ATTR;
  /* by not specifying INT or OBJ we should suit both */
}
