/* TAB.H ************************************************************** 
** ALang Execution/Mutation Engine: Version 0.61
** Part of Project von Neumann
** Copyright Dr I G Badcoe (I.Badcoe"bristol.ac.uk),
**           Toby Dickenson (htrd@tcp.co.uk) and
**           the Directors of Project von Neumann.
**
** License is granted for the use of this software only as part of
** Project von Neumann.
*/

#ifndef _TAB_H_
#define _TAB_H_

/* struct AL_Tabs are created as local variables during serialization
** to determine the tabstop information when drawing the AL_Node tree.
*/

struct AL_Tab {
  struct AL_Tab *prev;
  int state;
  int gap;
};

extern const char Tree_Section[];

void FTab_Middle(struct AL_Tab * tab, FILE * f);

void FTab_Last(struct AL_Tab * tab, FILE * f);

void FTab_Unary(struct AL_Node * where, struct AL_Tab * tab, FILE * f,
                 int gap, struct AL_Tab * prev);

void FTab_First(struct AL_Node * where, struct AL_Tab * tab, FILE * f,
                 int gap, struct AL_Tab * prev);

#endif /* _TAB_H_ */

